common/urls.py
# -*- coding: utf-8 -*-

from __future__ import unicode_literals

from django.conf.urls import url
from . import views

app_name = 'common'

urlpatterns = [
    # index
    url(r'^$',        views.index,     name='index'),
    # None
    url(r'^none/',    views.None404,        name='none'),
    # About
    url(r'^about/$', views.About.as_view(), name='about'),

    # About
    url(r'^config/$', views.config, name='config'),
]

expedientes/urls.py
# -*- coding: utf-8 -*-

from __future__ import unicode_literals

from django.conf.urls import url
from . import views



app_name = 'expediente'

urlpatterns = [
    #url(r'^$',                            views.home, name='home'),

    # Inicio
    url(r'^$', views.Home.as_view(), name='home'),
    # Expedientes
    url(r'^expedient/$', views.ExpedienteList.as_view(), name="expedientes13"),
    url(r'^expedient/$', views.ExpedienteList.as_view(), name="expedientes"),

    url(r'^expedient/reception$',  views.ExpedientRList.as_view(), name="listER"),
    url(r'^expedient/process$',    views.ExpedientPList.as_view(), name="listEP"),
    url(r'^expedient/history$',    views.ExpedientHList.as_view(), name="listEH"),


    # Details views
    # Expediente
    url(r'^expedient/(?P<id>[0-9a-z-]+)/$', views.ExpedienteDetail.as_view(),  name="expediente"),

    # evidences
    url(r'^evidence/attached/(?P<id>[0-9a-z-]+)/$', views.EvidenceAttachedDetail.as_view(),  name="attached"),
    url(r'^evidence/collection/(?P<id>[0-9a-z-]+)/$', views.EvidenceCollectionDetail.as_view(),  name="collection"),
]

ptt-amb/urls.py
from django.conf.urls import include, url
from django.contrib import admin
from django.views.generic.base import TemplateView
from django.contrib.auth import views as auth_views
#from filebrowser.sites import site
admin.autodiscover()
#import xadmin
#xadmin.autodiscover()

urlpatterns = [

    url(r'^',                   include('common.urls',    namespace='com')),
    url(r'^admin/',             admin.site.urls),
    url(r'^activity/',          include('actstream.urls')),
    url(r'^auth/',              include('django.contrib.auth.urls')),
    url(r'^accounts/',          include('registration.backends.default.urls')),
    url(r'^accounts/profile/',  include('myprofile.urls')),
    url(r'^actions/',           include('actions.urls')),

    #url(r'xadmin/',            include(xadmin.site.urls)),
    #url(r'^myapp/',            include('myapp.urls')),
    #url(r'^test/',             include('test_app.urls')),
    #url(r'^article/',          include('articles.urls',        namespace='articles')),
    #url(r'^org/',              include('organizacion.urls',   namespace='org')),
    url(r'^exp/',               include('expedientes.urls',    namespace='exp')),
    url(r'^sol/',               include('solicitud.urls',    namespace='sol')),
    url(r'^spatial/',           include('spatialMod.urls',    namespace='spa')),
    #url(r'^common/', include('common.urls', namespace='common')),

]

from django.conf.urls import (
handler400, handler403, handler404, handler500
)

#handler400 = 'my_app.views.bad_request'
#handler403 = 'my_app.views.permission_denied'
handler404 = 'common.views.None404'
#handler500 = 'my_app.views.server_error'

expedientes/models.py
import uuid
from django.db import models
from django.contrib.auth.models import User
from django.core.validators import RegexValidator
from common.choices import STATE, COORDINACIONES, MUNICIPIOS, SOLICITUDES, BANCOS, ADJUNTOS, TERRITORIOS, JUSTIFICACIONES, ALTURAS
from django.urls import reverse
from myprofile.models import UserProfile
from datetime import  datetime, timedelta, date
from django.utils import timezone
from django_extensions.db.models import TimeStampedModel
from common.models import Deadline, CapitalizePhrase
from common.Yurs import getDateDay
#from filebrowser.fields import FileBrowseField

#from filer.fields.image import FilerFileField

class Expedient(TimeStampedModel):
    id = models.UUIDField(primary_key=True, default=uuid.uuid4, editable=False)
    name = models.CharField("nombre", max_length=200, blank=True, null=True, )
    description = models.TextField("descripcion", max_length=200, blank=True, null=True, )
    state = models.CharField("Estado", max_length=100,choices=STATE, default=' ')

    def get_absolute_url(self):
        return reverse('expediente:expediente', kwargs={'id': self.id})
        #return reverse('expedientes', kwargs={'id': str(self.id)})
        # return "/gea/expedientes/%i" % self.id # MAL: poco portable

    def have_a_deadline(self):
        return False

    def is_nearly_change(self, d=2):
        """
        Return ``True`` if was change is nearly about d, default is 2 days
        """
        return self.modified < timezone.now() - timezone.timedelta(d)
        #return False

    is_nearly_change.boolean = True

    def solicitud_count(self):
        """Devuelve la cantidad de solicitudes que figuran en el expediente."""
        return self.attached_set.filter().count()

    def save(self):
        if(not self.name):
            # esto es porque tiene expediente pero no se ha respondido
            self.name = "Exp" + getDateDay(0)

        super(Expedient, self).save()


    class Meta:
        ordering = ['-modified']

    def __str__(self):
        return str(self.name)

class Collection(TimeStampedModel):
    id = models.UUIDField(primary_key=True, default=uuid.uuid4, editable=False)
    idExpedient = models.ForeignKey(Expedient, blank=True, null=True, on_delete=models.CASCADE)
    bank = models.CharField("Banco", max_length=200,choices=BANCOS, default='')
    value = models.DecimalField("Valor", max_digits=15, decimal_places=2, default='0,00')
    createDate = models.DateTimeField("Fecha de creacion", auto_now_add=True)
    name = models.CharField("nombre", max_length=200, blank=True, null=True, )
    description = models.TextField("descripcion", max_length=200, blank=True, null=True, )

    def get_absolute_url(self):
        return reverse('expediente:collection', kwargs={'id': self.id})
        #return reverse('expedientes', kwargs={'id': str(self.id)})
        # return "/gea/expedientes/%i" % self.id # MAL: poco portable

    def save(self):
        if(not self.name):
            # esto es porque tiene expediente pero no se ha respondido
            self.name = str(self.value) + " de " + self.bank

        super(Collection, self).save()
    def __str__(self):
        return str(self.name)

class Attached(TimeStampedModel):
    id = models.UUIDField(primary_key=True, default=uuid.uuid4, editable=False)
    typeAttached = models.CharField(max_length=200,choices=ADJUNTOS, default='')
    idExpedient = models.ForeignKey(Expedient, blank=True, null=True, on_delete=models.CASCADE)
    name = models.CharField("nombre", max_length=200, blank=True, null=True, )
    description = models.TextField("descripción", blank=True, null=True, )
    upload = models.FileField(upload_to='uploads/')

    def get_absolute_url(self):
        return reverse('expediente:attached', kwargs={'id': self.id})
        #return reverse('expedientes', kwargs={'id': str(self.id)})
        # return "/gea/expedientes/%i" % self.id # MAL: poco portable

    def save(self):
        if(not self.name):
            # esto es porque tiene expediente pero no se ha respondido
            self.name = self.typeAttached
        super(Attached, self).save()
    def __str__(self):
        return str(self.name)

expedientes/forms.py
from django import forms
from django.forms import ModelForm

expedientes/views.py
from django.shortcuts import render_to_response,get_object_or_404, render
from django.template.context import RequestContext
from django.http import HttpResponse,HttpResponseRedirect
from django.contrib.auth.decorators import login_required
from django.utils.decorators import method_decorator
from common.Yurs import getUnike, getRandomSome, getRandomSome1

from django import forms
from django.db.models import Q

from .models import Expedient
from .models import *
from solicitud.models import PTT

from django.views.generic import TemplateView, ListView, DetailView


class CounterMixin(object):

    def get_context_data(self, **kwargs):
        context = super(CounterMixin, self).get_context_data(**kwargs)
        context['count'] = self.get_queryset().count()
        return context


class SearchMixin(object):

    def get_queryset(self):
        qset = super(SearchMixin, self).get_queryset()
        q = self.request.GET.get('search')
        if q:
            q = q.split(' ')
            for w in q:
                qset = qset.filter(
                    Q(id__contains=w) |
                    Q(name__contains=w)|
                    Q(description__contains=w)
                    #Q(inscripcion_numero__contains=w) |
                    #Q(expedientepartida__partida__pii__contains=w) |
                    #Q(expedientepersona__persona__nombres__icontains=w) |
                    #Q(expedientepersona__persona__apellidos__icontains=w) |
                    #Q(expedientelugar__lugar__nombre__icontains=w)
                ).distinct()
        return qset

class ExpedientRecepcionMixin(object):

    def get_queryset(self):
        qset = super(ExpedientRecepcionMixin, self).get_queryset()
        qset = qset.filter(
            Q(state='Reciente')
            #Q(id='336f8ecd-9eaa-4644-80f6-141300c07eb9')
            #Q(1=1)
            #Q(inscripcion_numero__isnull=True) &
            #Q(cancelado=False) &
            #Q(sin_inscripcion=False)
        )
        return qset

class ExpedientProcessMixin(object):

    def get_queryset(self):
        qset = super(ExpedientProcessMixin, self).get_queryset()
        qset = qset.filter(
            Q(state='En Proceso')
            #Q(id='336f8ecd-9eaa-4644-80f6-141300c07eb9')
            #Q(1=1)
            #Q(inscripcion_numero__isnull=True) &
            #Q(cancelado=False) &
            #Q(sin_inscripcion=False)
        )
        return qset

class ExpedientHistoryMixin(object):

    def get_queryset(self):
        qset = super(ExpedientHistoryMixin, self).get_queryset()
        qset = qset.filter(
            Q(state='Historicas')
            #Q(id='336f8ecd-9eaa-4644-80f6-141300c07eb9')
            #Q(1=1)
            #Q(inscripcion_numero__isnull=True) &
            #Q(cancelado=False) &
            #Q(sin_inscripcion=False)
        )
        return qset


class ExpedientRList(CounterMixin, SearchMixin, ExpedientRecepcionMixin, ListView):
    template_name = 'lists/expediente_list.html'
    model = Expedient
    paginate_by = 10

    def get_paginate_by(self, queryset):
        """
        Paginate by specified value in querystring, or use default class
        property value.
        """
        return self.request.GET.get('paginate_by', self.paginate_by)

    #@method_decorator(login_required)
    def dispatch(self, *args, **kwargs):
        return super(ExpedientRList, self).dispatch(*args, **kwargs)


class ExpedientPList(CounterMixin, SearchMixin, ExpedientProcessMixin, ListView):
    template_name = 'lists/expediente_list.html'
    model = Expedient
    paginate_by = 10

    def get_paginate_by(self, queryset):
        """
        Paginate by specified value in querystring, or use default class
        property value.
        """
        return self.request.GET.get('paginate_by', self.paginate_by)

    #@method_decorator(login_required)
    def dispatch(self, *args, **kwargs):
        return super(ExpedientPList, self).dispatch(*args, **kwargs)


class ExpedientHList(CounterMixin, SearchMixin, ExpedientHistoryMixin, ListView):
    template_name = 'lists/expediente_list.html'
    model = Expedient
    paginate_by = 10

    def get_paginate_by(self, queryset):
        """
        Paginate by specified value in querystring, or use default class
        property value.
        """
        return self.request.GET.get('paginate_by', self.paginate_by)

    #@method_decorator(login_required)
    def dispatch(self, *args, **kwargs):
        return super(ExpedientHList, self).dispatch(*args, **kwargs)


class ExpedienteAbiertoMixin(object):

    def get_queryset(self):
        qset = super(ExpedienteAbiertoMixin, self).get_queryset()
        qset = qset.filter(
            #Q(modifyDate__gt=datetime.date(2017, 10, 5))
            #Q(id='336f8ecd-9eaa-4644-80f6-141300c07eb9')
            #Q(1=1)
            #Q(inscripcion_numero__isnull=True) &
            #Q(cancelado=False) &
            #Q(sin_inscripcion=False)
        )[:10]
        return qset


class Home(CounterMixin, SearchMixin, ExpedienteAbiertoMixin, ListView):
    template_name = 'home/index.html'
    model = Expedient

    def get_context_data(self, *args, **kwargs):
        context = super(Home, self).get_context_data(*args, **kwargs)
        # last 5 inscriptos
        context['insc_list'] = \
            Expedient.objects.filter(
                #Q(modifyDate__gt=datetime.date(2017, 5, 10))
                #Q(id='336f8ecd-9eaa-4644-80f6-141300c07eb9')
                #Q(modified__isnull=False) &
                #Q(inscripcion_fecha__isnull=False)
            ).order_by('-modified')[:5]
        return context

    #@method_decorator(login_required)
    def dispatch(self, *args, **kwargs):
        return super(Home, self).dispatch(*args, **kwargs)


class ExpedienteList(CounterMixin, SearchMixin, ListView):
    template_name = 'lists/expediente_list.html'
    model = Expedient
    paginate_by = 10

    def get_paginate_by(self, queryset):
        """
        Paginate by specified value in querystring, or use default class
        property value.
        """
        return self.request.GET.get('paginate_by', self.paginate_by)

    #@method_decorator(login_required)
    def dispatch(self, *args, **kwargs):
        return super(ExpedienteList, self).dispatch(*args, **kwargs)

class ExpedienteDetail(DetailView):
    template_name = 'lists/expediente_detail.html'
    model = Expedient
    slug_url_kwarg = 'id'
    slug_field = 'id'


    @method_decorator(login_required)
    def dispatch(self, *args, **kwargs):
        return super(ExpedienteDetail, self).dispatch(*args, **kwargs)

    def get_context_data(self, **kwargs):
        context = super(ExpedienteDetail, self).get_context_data(**kwargs)
        context['attached_list'] = Attached.objects.filter(idExpedient=self.object.id)
        context['collection_list'] = Collection.objects.filter(idExpedient=self.object.id)
        context['solicitud_list'] = PTT.objects.filter(idExpedient=self.object.id)

        return context

class EvidenceAttachedDetail(DetailView):
    template_name = 'evidence/attached.html'
    model = Attached
    slug_url_kwarg = 'id'
    slug_field = 'id'


    @method_decorator(login_required)
    def dispatch(self, *args, **kwargs):
        return super(EvidenceAttachedDetail, self).dispatch(*args, **kwargs)


class EvidenceCollectionDetail(DetailView):
    template_name = 'evidence/collection.html'
    model = Collection
    slug_url_kwarg = 'id'
    slug_field = 'id'


    @method_decorator(login_required)
    def dispatch(self, *args, **kwargs):
        return super(EvidenceCollectionDetail, self).dispatch(*args, **kwargs)

expedientes/templates/lists/expediente_detail.html
{% extends "base.html" %}
{% block title %}AMB | Expediente {{ object.name }}{% endblock title %}

{# set menu in active mode #}
{% block nav-exp %} class="active"{% endblock %}

{% block content %}
{% load static from staticfiles %}
<div class="col-lg-8">

<div class="ui grid">
    <div class="ten wide column">
      <div class="col-md-offset-3 column">
          <h1><i class="fa fa-folder"></i><a href="#"> {{ object.name }}</a></h1>
      </div>
      <table class="table table-folder-information">
          <tbody>
              <tr>
                  <th class="col-md-3 text-right">Fecha de Creación</th>
                  <td>{{ object.created }}</td>
              </tr>
              <tr>
                  <th class="col-md-3 text-right">Ultima Modificación</th>
                  <td>{{ object.modified }}</td>
              </tr>
          </tbody>
      </table>

      <a href="/admin/expedientes/expedient/{{ object.id }}/"class="ui primary button">Editar</a>
      <a href="#" onclick="window.history.back(); return false;" title="Cancel" class="ui button">
          <div class="btn-floating waves-effect waves-light red">Volver</div>
      </a>
    </div>
    <div class="six wide column">

      <h3> Resumen Evidencias</h3>
      <table class="table table-evicence-information">
        <thead>
          <tr>
            <th>Cantidad</th>
            <th>Tipo</th>
          </tr>
        </thead>
        <tbody>
          <tr><!-- SOLICITUDES -->
            <td>{{ solicitud_list.count }}</td>
            <td>Solicitudes</td>
          </tr>
          <tr><!-- ATTACHED -->
            <td>{{ attached_list.count }}</td>
            <td>Documentos Adjuntos</td>
          </tr>
          <tr><!-- COLLECTION -->
            <td>{{ collection_list.count }}</td>
            <td>Recaudos</td>
          </tr>
        </tbody>
      </table>

    </div>
</div>
    <h3>Evidencias del Expediente</h3>

    <table class="ui sortable celled table">
      <thead>
        <tr>
          <th>Tipo de Evidencia</th>
          <th>Nombre</th>
          <th>Descripción</th>
          <th>Deadline</th>
          <th>Fecha</th>
        </tr>
      </thead>
      <tbody>
        {% for e in solicitud_list %}
        <tr><!-- ATTACHED -->
          <td> <a href="{{e.get_absolute_url}}" class="circular ui button">
            <i class="fa fa-file-text" aria-hidden="true"></i>
          </a></td>

          <td><a href="{{e.get_absolute_url}}">{{ e.name }}</a></td>
          <td>{{ e.description }}</td>
          <td> {{ e.have_a_deadline }}</td>
          <td>{{ e.modified }}</td>
          </td>
        </tr>

        {% endfor %}
        {% for e in attached_list %}
        <tr><!-- ATTACHED -->
          <td> <a href="{{e.get_absolute_url}}" class="circular ui button"><i class="fa fa-paperclip" aria-hidden="true"></i></a></td>
          <td><a href="{{e.get_absolute_url}}">{{ e.name }}</a></td>
          <td>{{ e.description }}</td>
          <td> {{ e.have_a_deadline }}</td>
          <td>{{ e.modified }}</td>
          </td>
        </tr>

        {% endfor %}
        {% for e in collection_list %}
        <tr><!-- ATTACHED -->
          <td> <a href="{{e.get_absolute_url}}" class="circular ui button">
            <i class="fa fa-money" aria-hidden="true"></i>
          </a></td>
          <td><a href="{{e.get_absolute_url}}">{{ e.name }}</a></td>
          <td>{{ e.description }}</td>
          <td> {{ e.have_a_deadline }}</td>
          <td>{{ e.modified }}</td>
          </td>
        </tr>

        {% endfor %}
      </tbody>
    </table>
</div>
{% endblock content %}

expedientes/templates/lists/expediente_list.html
{% extends "base.html" %}
{% block title %}AMB | Listado de Expedientes{% endblock title %}

{# set menu in active mode #}
{% block nav-list-exp %} class="active"{% endblock %}

{% block content %}
<div class="page-header">
  <h1><i class="fa fa-folder"></i> <a href="{% url 'expediente:expedientes13' %}">Listado de Expedientes</a></h1>
  <strong>{{ count }}</strong> expediente{% if count > 1 %}s{% endif %} filtrado{% if count > 1 %}s{% endif %}
</div>
<div class="well well-sm col-md-12">
  <form class="navbar-form" action="." method="get">
        <div class="ui search">
          <span class="input-group-addon"><i class="fa fa-folder"></i></span>
          <input type="text" id="search" name="search" placeholder="Expediente" class="form-control prompt" value="{{ request.GET.search }}" size="35">
          <div class="results"></div>
          <button class="circular ui icon button">
            <i class="fa fa-search"></i>
          </button>
        </div>
  </form>
</div>
{% include "_pagination.html" %}
<table class="ui sortable celled table">
  <thead>
    <tr>
      <th>Nombre</th>
      <th>Descripción</th>
      <th>Fecha </th>
    </tr>
  </thead>
  <tbody>
    {% for e in object_list %}
    <tr><!-- EXPEDIENTE -->

      <td><a href="{{e.get_absolute_url}}">{{ e.name }}</a></td>
      <td> {{ e.description }}</td>
      <td>  {{ e.modified|date:"d/m/y" }}  <p class="circular ui button" data-tooltip="{{ e.modified|date:"D/M/Y - h : i : s A" }}"> <i class="fa fa-calendar" ></i>
    </p>   </td>
      </td>
    </tr>
    {% empty %}
    <div class="alert alert-info" role="alert">
      <i class="fa fa-info-circle" aria-hidden="true"></i>
      <span class="sr-only">Información:</span>
      No se encontraron Expedientes.
    </div>
    {% endfor %}
  </tbody>
</table>
{% include "_pagination.html" %}
{% endblock content %}